/**
 * This in a class which represents a lab.
 * this class includes a number of students
 * in itself which are given to the defined
 * lab by a method and sores them in a neat way
 * @author Reza Farahbakhsh
 * @since 12/3/2021
 * @version 1.0
 */
public class Lab {
    private int avg = 0;
    private String day;
    private int capacity;
    private int currentSize;
    private Student[] students = new Student[capacity];
    public Lab(int cap, String d) {
        capacity = cap;
        day = d;
    }

    /**
     * method to update the maximum capacity of lab after defining it
     */
    public void updateSize() {
        students = new Student[capacity];
    }

    /**
     * a method to add the given student to the defined lab
     * @param std
     */
    public void enrollStudent(Student std) {
        if (currentSize < capacity) {
            students[currentSize] = std;
            currentSize++;
        } else {
            System.out.println("Lab is full!!!");
        }
    }

    /**
     * a method to print the stored information in neat way
     */
    public void print() {
        for(int i = 0; i < currentSize; i++) {
            String name = students[i].getFirstName();
            String id = students[i].getId();
            int grade = students[i].getGrade();
            System.out.println("std first name: " + name
                             + " std id:" + id
                             + " std grade:"+ grade);
        }
        System.out.println("Grade average: " + avg);
    }

    /**
     * method to get the current size of students from across other classes
     * @return currentSize
     */
    public int getSize() {
        return currentSize;
    }

    /**
     * method to get the array of all the students from across other classes
     * @return students
     */
    public Student[] getStudents() {
        return students;
    }

    /**
     * method to replace an array of students from other classes to this class
     * @param std
     */
    public void setStudents(Student[] std) {
        students = std;
    }

    /**
     * method to get the average of students' grades from across other classes
     * @return avg
     */
    public int getAvg() {
        return avg;
    }

    /**
     * method to calculate the average of grades
     */
    public void calculateAvg() {
        for(int i = 0; i < currentSize; i++) {
            avg += students[i].getGrade();
        }
        avg /= currentSize;
    }

    /**
     * method to know what day the lab is starting by other classes
     * @return day
     */
    public String getDay() {
        return day;
    }

    /**
     * method to change what day lab starts by other classes
     * @param d
     */
    public void setDay(String d) {
        day = d;
    }

    /**
     * method to get the maximum capacity of students in a lab by other classes
     * @return capacity
     */
    public int getCapacity() {
        return capacity;
    }

    /**
     * method to change the maximum capacity of students by other classes
     * @param cap
     */
    public void setCapacity(int cap) {
        capacity = cap;
    }
}
